program RenameMaster;










uses
  Forms,
  Windows,
  SysUtils,
  Dialogs,
  classes,
  UnitFolderWriteTest in 'UnitFolderWriteTest.pas',
  DiskTreeView in 'DiskTreeView.pas',
  UnitFrmMain in 'UnitFrmMain.pas' {FrmMain},
  //UnitFrmSelectFolder in 'UnitFrmSelectFolder.pas' {frmSelectFolder},
  UnitMetaVariables in 'UnitMetaVariables.pas',
  //UnitFrmMetaVariables in 'UnitFrmMetaVariables.pas' {frmMetaVariablesOld1},
  UnitFrmConfig in 'UnitFrmConfig.pas' {frmConfig},
  UnitFrmSelectFolderNew in 'UnitFrmSelectFolderNew.pas' {frmSelectFolderNew},
  UnitListViewMover in 'UnitListViewMover.pas',
  UnitWildcards in 'UnitWildcards.pas',
  UnitToken in 'UnitToken.pas',
  UnitStates in 'UnitStates.pas',
  UnitRMScript in 'UnitRMScript.pas',
  UnitFrmError in 'UnitFrmError.pas' {frmError},
  UnitFrmUndo in 'UnitFrmUndo.pas' {frmUndo},
  UnitFrmAbout in 'UnitFrmAbout.pas' {FrmAbout},
  UnitDummyShellForm in 'UnitDummyShellForm.pas' {FrmDummyShellForm},
  UnitFoldersCount in 'UnitFoldersCount.pas',
  UnitFrmCollisionDialog in 'UnitFrmCollisionDialog.pas' {FrmCollisionDialog},
  UnitUtil in 'UnitUtil.pas',
  UnitFileTags in 'UnitFileTags.pas',
  UnitFileIcon in 'UnitFileIcon.pas',
  UnitFrmEdit in 'UnitFrmEdit.pas' {FrmEdit},
  UnitFrmFilter in 'UnitFrmFilter.pas' {FrmFilter},
  UnitFrmDummyPreview in 'UnitFrmDummyPreview.pas' {FrmDummyAutoPreview},
  UnitFrmThumbPreview in 'UnitFrmThumbPreview.pas' {FrmThumbPreview},
  UnitColumnManager in 'UnitColumnManager.pas',
  UnitFrmDummyShowPreview in 'UnitFrmDummyShowPreview.pas' {FrmDummyShowPreview},
  UnitFrmDummyThumbExtract in 'UnitFrmDummyThumbExtract.pas' {FrmDummyThumbExtract},
  UnitSpecialPaths in 'UnitSpecialPaths.pas',
  UnitFrmNewFolder in 'UnitFrmNewFolder.pas' {FrmNewFolder},
  UnitFrmExclude in 'UnitFrmExclude.pas' {FrmExclude},
  UnitFrmWizardGettingStarted in 'UnitFrmWizardGettingStarted.pas' {FrmWizardGettingStarted},
  UnitScriptActions in 'UnitScriptActions.pas',
  UnitFrmScriptActions in 'UnitFrmScriptActions.pas' {FrmScriptActions},
  UnitFrmCustomColumns in 'UnitFrmCustomColumns.pas' {FrmCustomColumns},
  UnitFrmInstance in 'UnitFrmInstance.pas' {FrmDummyInstance},
  UnitTextFileFormat in 'UnitTextFileFormat.pas',
  UnitFrameTextfile in 'UnitFrameTextfile.pas' {FrameTextfield: TFrame},
  UnitFrmSaveScript in 'UnitFrmSaveScript.pas' {FrmSaveScript},
  UnitFrmFiletags in 'UnitFrmFiletags.pas' {FrmFileTags},
  UnitFrmWizardTextfile in 'UnitFrmWizardTextfile.pas' {FrmWizardTextfile},
  UnitFrameFolderDropdown in 'UnitFrameFolderDropdown.pas' {FrameFolderDropdown: TFrame},
  UnitFrameCrumb in 'UnitFrameCrumb.pas' {FrameCrumb: TFrame},
  UnitFrameBreadcrumb in 'UnitFrameBreadcrumb.pas' {FrameBreadcrumbs: TFrame},
  UnitFrameStep in 'UnitFrameStep.pas' {FrameStep: TFrame},
  UnitFrameToolbar in 'UnitFrameToolbar.pas' {FrameToolbar: TFrame},
  UnitAutoSplit in 'UnitAutoSplit.pas',
  MSXML2_TLB in 'c:\program files (x86)\borland\bds\4.0\Imports\MSXML2_TLB.pas',
  UnitFrmGenerateBatch in 'UnitFrmGenerateBatch.pas' {frmGenerateBatch},
  UnitFrmScriptStepHelp in 'UnitFrmScriptStepHelp.pas' {FrmScriptStepHelp},
  UnitVideo in 'UnitVideo.pas',
  Vcl.Themes,
  Vcl.Styles,
  UnitDebug in 'UnitDebug.pas',
  UnitFrmCheckForUpdate in '..\CheckForUpdate\UnitFrmCheckForUpdate.pas' {FrmCheckForUpdate},
  UnitUndoRename in 'UnitUndoRename.pas',
  UnitFrameFilter in 'UnitFrameFilter.pas' {FrameFilter: TFrame},
  UnitFolderMonitor in 'UnitFolderMonitor.pas',
  UnitFrmRenameProgress in 'UnitFrmRenameProgress.pas' {FrmRenameProgress},
  UnitMyRichEdit in 'UnitMyRichEdit.pas',
  UnitFrameCheckFilesDropdown in 'UnitFrameCheckFilesDropdown.pas' {FrameCheckedFileDropdown: TFrame},
  UnitFrameDropDown in 'UnitFrameDropDown.pas' {FrameDropDown: TFrame},
  UnitFrmMetaVariables2 in 'UnitFrmMetaVariables2.pas' {frmMetaVariables},
  UnitAutoBackup in '..\AutoBackup\UnitAutoBackup.pas',
  UnitFrameFileTags in 'UnitFrameFileTags.pas' {framFileTags: TFrame},
  UnitCRC32 in '..\AutoBackup\UnitCRC32.PAS',
  UnitSetScreenCursor in '..\CheckForUpdate\UnitSetScreenCursor.pas',
  UnitFormScaling in 'UnitFormScaling.pas';

{$R *.res}

  procedure MakeForm(ic : TComponentClass; var reference);
  var c, x : cardinal;
  begin
    c := Windows.GetTickCount;
    Application.CreateForm(ic, reference);
    x := Windows.GetTickCount - c;
    DebugLog.Append(ic.ClassName + ' tick ' + IntToStr(x));
  end;
begin
  Application.Initialize;
  Application.ShowMainForm := false;
  Application.OnException := FrmError.MyExceptionHandler;

  if Application.Terminated then EXIT;
    
  // Made each form mutualy exclusive (using InitForm)
  // No more deadlock requirements for form X to be
  // created before form Y


  //Application.DefaultFont.Size := trunc( Application.DefaultFont.Size  * 0.55);

  //Application.CreateForm(TfrmMain, frmMain);
  DebugLog.StartTimer();
  makeform(TFrmMain, frmMain);
  makeform(TFrmThumbPreview, FrmThumbPreview);
  //Application.CreateForm(TfrmMetaVariablesOld1, frmMetaVariablesOld1);
  makeform(TFrmDummyAutoPreview, FrmDummyAutoPreview);
  makeform(TfrmConfig, frmConfig);
  makeform(TFrmDummyShowPreview, FrmDummyShowPreview);
  makeform(TFrmCollisionDialog, FrmCollisionDialog);
  //makeform(TfrmSelectFolder, frmSelectFolder);
  makeform(TfrmSelectFolderNew, frmSelectFolderNew);
  makeform(TfrmError, frmError);
  makeform(TfrmUndo, frmUndo);
  makeform(TFrmAbout, FrmAbout);
  makeform(TFrmDummyShellForm, FrmDummyShellForm);
  makeform(TFrmEdit, FrmEdit);
  makeform(TFrmFilter, FrmFilter);
  makeform(TFrmDummyThumbExtract, FrmDummyThumbExtract);
  makeform(TFrmNewFolder, FrmNewFolder);
  makeform(TFrmExclude, FrmExclude);
  makeform(TFrmWizardGettingStarted, FrmWizardGettingStarted);
  makeform(TFrmScriptActions, FrmScriptActions);
  makeform(TFrmCustomColumns, FrmCustomColumns);
  makeform(TFrmSaveScript, FrmSaveScript);
  makeform(TFrmFileTags, FrmFileTags);
  makeform(TFrmWizardTextfile, FrmWizardTextfile);
  makeform(TfrmGenerateBatch, frmGenerateBatch);
  makeform(TFrmScriptStepHelp, FrmScriptStepHelp);
  makeform(TFrmCheckForUpdate, FrmCheckForUpdate);
  makeform(TFrmRenameProgress, FrmRenameProgress);
  makeform(TfrmMetaVariables, frmMetaVariables);

  DebugLog.EndTimer('End Of Form Loading: ');

  FrmConfig.PerformScaling;

  // this form is ONLY created by the intance process
 // Application.CreateForm(TFrmDummyInstance, FrmDummyInstance);
    //frmmain.Position := poScreenCenter;

    // this disable drag-and-drop for some reason
    if not FileExists(GetINIPath)  then begin
        frmmain.Position := poScreenCenter;
    end;


    FrmInstance_Init; // this may terminate execution
    //if not application.Terminated  then begin

        Application.ProcessMessages;
        if (not Application.Terminated) then begin
            frmmain.InitForm;
            Application.ProcessMessages;
            if (not application.Terminated)  then begin
                frmmain.Show;
                FrmMain.FlagActivated;
                frmmain.SyncBrowserPane;
            end;
        end;


        if not application.Terminated then
            Application.Run;
        FrmInstance_DeInit;
    //end else begin
    //    halt;
    //end;

end.
